// SPDX-License-Identifier: BSD-2-Clause
/*
 * Copyright (C) 2017 The Android Open Source Project
 */
// #include <common.h>
#include <android_ab.h>
#include <android_bootloader_message.h>
// #include <blk.h>
#include <log.h>
// #include <malloc.h>
#include <string.h>
// #include <part.h>
// #include <memalign.h>
// #include <linux/err.h>
#include <errno.h>
// #include <u-boot/crc.h>
#include <crc.h>

#include <emmc_multiboot.h>
#include <image_load_emmc.h>
#include <mem_io.h>
typedef unsigned long int	ulong;
typedef uint32_t	u32;
#define typeof(x)	__typeof__(x)
#define DIV_ROUND_UP(n,d)	(((n) + (d) - 1) / (d))
#define ARRAY_SIZE(x)		(sizeof(x) / sizeof((x)[0]))

volatile uint8_t *_disk_buffer = (volatile uint8_t *)DISK_BUFFER_ADDR;

/**
 * Compute the CRC-32 of the bootloader control struct.
 *
 * Only the bytes up to the crc32_le field are considered for the CRC-32
 * calculation.
 *
 * @param[in] abc bootloader control block
 *
 * @return crc32 sum
 */
static uint32_t ab_control_compute_crc(struct bootloader_control *abc)
{
	return crc32(0, (void *)abc, offsetof(typeof(*abc), crc32_le));
}

/**
 * Initialize bootloader_control to the default value.
 *
 * It allows us to boot all slots in order from the first one. This value
 * should be used when the bootloader message is corrupted, but not when
 * a valid message indicates that all slots are unbootable.
 *
 * @param[in] abc bootloader control block
 *
 * @return 0 on success and a negative on error
 */
static int ab_control_default(struct bootloader_control *abc)
{
	int i;
	const struct slot_metadata metadata = {
		.priority = 15,
		.tries_remaining = 7,
		.successful_boot = 0,
		.verity_corrupted = 0,
		.reserved = 0
	};

	if (!abc)
		return -EFAULT;

	memcpy(abc->slot_suffix, "a\0\0\0", 4);
	abc->magic = BOOT_CTRL_MAGIC;
	abc->version = BOOT_CTRL_VERSION;
	abc->nb_slot = NUM_SLOTS;
	memset(abc->reserved0, 0, sizeof(abc->reserved0));
	for (i = 0; i < abc->nb_slot; ++i)
		abc->slot_info[i] = metadata;

	memset(abc->reserved1, 0, sizeof(abc->reserved1));
	abc->crc32_le = ab_control_compute_crc(abc);

	return 0;
}

/**
 * Load the boot_control struct from disk into newly allocated memory.
 *
 * This function allocates and returns an integer number of disk blocks,
 * based on the block size of the passed device to help performing a
 * read-modify-write operation on the boot_control struct.
 * The boot_control struct offset (2 KiB) must be a multiple of the device
 * block size, for simplicity.
 *
 * @param[in] dev_desc Device where to read the boot_control struct from
 * @param[in] part_info Partition in 'dev_desc' where to read from, normally
 *			the "misc" partition should be used
 * @param[out] pointer to pointer to bootloader_control data
 * @return 0 on success and a negative on error
 */
static int ab_control_create_from_disk(
				    //    struct blk_desc *dev_desc,
				    //    const struct disk_partition *part_info,
				       struct bootloader_control **abc)
{
	// ulong abc_offset, abc_blocks, ret;

	// abc_offset = offsetof(struct bootloader_message_ab, slot_suffix);
	// if (abc_offset % CX_EMMC_SECTOR_SIZE) {
	// 	ERROR("Boot control block not block aligned.\n");
	// 	return -EINVAL;
	// }
	// abc_offset /= CX_EMMC_SECTOR_SIZE;

	// abc_blocks = DIV_ROUND_UP(sizeof(struct bootloader_control),
	// 			  CX_EMMC_SECTOR_SIZE);
	// if (abc_offset + abc_blocks > part_info->size) {
	// 	ERROR("boot control partition too small. Need at"
	// 		" least %lu blocks but have %lu blocks.\n",
	// 		abc_offset + abc_blocks, part_info->size);
	// 	return -EINVAL;
	// }
	// *abc = malloc_cache_aligned(abc_blocks * CX_EMMC_SECTOR_SIZE);
	// if (!*abc)
	// 	return -ENOMEM;

	// [ab_control_create_from_disk:112] start 0x3f800(260096), abc_offset(0x4,4), blocks 1
	// ret = blk_dread(dev_desc, part_info->start + abc_offset, abc_blocks,
	// 		*abc);
    uint32_t rtn_val = EMMC_DEV_ERR;

#define CX_EMMC_MISC_PART	0			// user partition
#define CX_EMMC_MISC_START	0x3F800		// 127MB in user partition
#define CX_EMMC_AB_CONTROL	(CX_EMMC_MISC_START + 4)
#define CX_EMMC_AB_SIZE		(1)
	rtn_val = emmc_trans_data(CX_EMMC_MISC_PART, (uintptr_t)(CX_EMMC_AB_CONTROL), 
                    (uintptr_t)_disk_buffer, CX_EMMC_AB_SIZE);
    if(EMMC_DEV_OK != rtn_val)
	{
		ERROR("Could not read from boot ctrl partition\n");
		*abc = NULL;
		return -EIO;
	}

	*abc = (struct bootloader_control *)_disk_buffer;
	return 0;
}

/**
 * Store the loaded boot_control block.
 *
 * Store back to the same location it was read from with
 * ab_control_create_from_misc().
 *
 * @param[in] dev_desc Device where we should write the boot_control struct
 * @param[in] part_info Partition on the 'dev_desc' where to write
 * @param[in] abc Pointer to the boot control struct and the extra bytes after
 *                it up to the nearest block boundary
 * @return 0 on success and a negative on error
 */
// static int ab_control_store(struct blk_desc *dev_desc,
// 			    const struct disk_partition *part_info,
// 			    struct bootloader_control *abc)
// {
// 	ulong abc_offset, abc_blocks, ret;

// 	abc_offset = offsetof(struct bootloader_message_ab, slot_suffix) /
// 		     part_info->blksz;
// 	abc_blocks = DIV_ROUND_UP(sizeof(struct bootloader_control),
// 				  part_info->blksz);
// 	ret = blk_dwrite(dev_desc, part_info->start + abc_offset, abc_blocks,
// 			 abc);
// 	if (IS_ERR_VALUE(ret)) {
// 		log_err("ANDROID: Could not write back the misc partition\n");
// 		return -EIO;
// 	}

// 	return 0;
// }

/**
 * Compare two slots.
 *
 * The function determines slot which is should we boot from among the two.
 *
 * @param[in] a The first bootable slot metadata
 * @param[in] b The second bootable slot metadata
 * @return Negative if the slot "a" is better, positive of the slot "b" is
 *         better or 0 if they are equally good.
 */
static int ab_compare_slots(const struct slot_metadata *a,
			    const struct slot_metadata *b)
{
	/* Higher priority is better */
	if (a->priority != b->priority)
		return b->priority - a->priority;

	/* Higher successful_boot value is better, in case of same priority */
	if (a->successful_boot != b->successful_boot)
		return b->successful_boot - a->successful_boot;

	/* Higher tries_remaining is better to ensure round-robin */
	if (a->tries_remaining != b->tries_remaining)
		return b->tries_remaining - a->tries_remaining;

	return 0;
}

int ab_select_slot(
	// struct blk_desc *dev_desc, struct disk_partition *part_info
	void
)
{
	struct bootloader_control *abc = NULL;
	u32 crc32_le;
	int slot, i, ret;
	bool store_needed = false;
	char slot_suffix[4];

	mem_write32(AB_INFO_FLAG_ADDR, AB_INFO_FLAG_INIT);
	ret = ab_control_create_from_disk(/*dev_desc, part_info,*/ &abc);
	if (ret < 0) {
		/*
		 * This condition represents an actual problem with the code or
		 * the board setup, like an invalid partition information.
		 * Signal a repair mode and do not try to boot from either slot.
		 */
		return ret;
	}

	crc32_le = ab_control_compute_crc(abc);
	if (abc->crc32_le != crc32_le) {
		ERROR("Invalid CRC-32 (expected %.8x, found %.8x),"
				"re-initializing A/B metadata.\n", crc32_le, abc->crc32_le);

		ret = ab_control_default(abc);
		if (ret < 0) {
			// free(abc);
			return -ENODATA;
		}
		store_needed = true;
	}

	if (abc->magic != BOOT_CTRL_MAGIC) {
		ERROR("Unknown A/B metadata: %.8x\n", abc->magic);
		// free(abc);
		return -ENODATA;
	}

	if (abc->version > BOOT_CTRL_VERSION) {
		ERROR("Unsupported A/B metadata version: %.8x\n", abc->version);
		// free(abc);
		return -ENODATA;
	}

	/*
	 * At this point a valid boot control metadata is stored in abc,
	 * followed by other reserved data in the same block. We select a with
	 * the higher priority slot that
	 *  - is not marked as corrupted and
	 *  - either has tries_remaining > 0 or successful_boot is true.
	 * If the selected slot has a false successful_boot, we also decrement
	 * the tries_remaining until it eventually becomes unbootable because
	 * tries_remaining reaches 0. This mechanism produces a bootloader
	 * induced rollback, typically right after a failed update.
	 */

	/* Safety check: limit the number of slots. */
	if (abc->nb_slot > ARRAY_SIZE(abc->slot_info)) {
		abc->nb_slot = ARRAY_SIZE(abc->slot_info);
		NOTICE("[%s:%d] abc->nb_slot > ARRAY_SIZE(abc->slot_info)\n", __func__, __LINE__);
		store_needed = true;
	}

	slot = -1;
	for (i = 0; i < abc->nb_slot; ++i) {
		if (abc->slot_info[i].verity_corrupted ||
		    !abc->slot_info[i].tries_remaining) {
			NOTICE("unbootable slot %d tries: %d, corrupt: %d\n",
				  i, abc->slot_info[i].tries_remaining,
				  abc->slot_info[i].verity_corrupted);
			continue;
		}
		NOTICE("bootable slot %d pri: %d, tries: %d, "
				"corrupt: %d, successful: %d\n",
			  i, abc->slot_info[i].priority,
			  abc->slot_info[i].tries_remaining,
			  abc->slot_info[i].verity_corrupted,
			  abc->slot_info[i].successful_boot);

		if (slot < 0 ||
		    ab_compare_slots(&abc->slot_info[i],
				     &abc->slot_info[slot]) < 0) {
			slot = i;
		}
	}

	if (slot >= 0 && !abc->slot_info[slot].successful_boot) {
		ERROR("Attempting slot %d, tries remaining %d\n",
			slot, abc->slot_info[slot].tries_remaining);
		abc->slot_info[slot].tries_remaining--;
		store_needed = true;
	}

	if (slot >= 0) {
		/*
		 * Legacy user-space requires this field to be set in the BCB.
		 * Newer releases load this slot suffix from the command line
		 * or the device tree.
		 */
		memset(slot_suffix, 0, sizeof(slot_suffix));
		slot_suffix[0] = BOOT_SLOT_NAME(slot);
		if (memcmp(abc->slot_suffix, slot_suffix,
			   sizeof(slot_suffix))) {
			memcpy(abc->slot_suffix, slot_suffix,
			       sizeof(slot_suffix));
			NOTICE("[%s:%d] slot_suffix is differ\n", __func__, __LINE__);
			store_needed = true;
		}
	}

	if (store_needed) {
		abc->crc32_le = ab_control_compute_crc(abc);
		// ab_control_store(dev_desc, part_info, abc);
		crc32_le = AB_INFO_FLAG_STORE;
	}
	else
		crc32_le = AB_INFO_FLAG_OK;
	// free(abc);
	if (slot == 1)
		crc32_le |= AB_INFO_SELECT_2nd;
	mem_write32(AB_INFO_FLAG_ADDR, crc32_le);

	if (slot < 0)
		return -EINVAL;

	return slot;
}
